/*
 * generated by Xtext 2.29.0
 * (c) EvoAl Project
 */
package de.evoal.languages.model.ol.dsl.ui.contentassist;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.ide.editor.contentassist.ContentAssistContext;
import org.eclipse.xtext.resource.IEObjectDescription;
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;

/**
 * See https://www.eclipse.org/Xtext/documentation/310_eclipse_support.html#content-assist
 * on how to customize the content assistant.
 */
public class OptimisationLanguageProposalProvider extends AbstractOptimisationLanguageProposalProvider {
	/*
	private void addInstanceDefinition(final TypeDefinition definition, final Name name, final Type type, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
		if(!definition.isAbstract()) {
			String proposal = definition.getName();
		
			if(definition.getAttributes().isEmpty()) {
				proposal += ";\n";
			} else {
				proposal += "{\n};\n";
			}
		
			StyledString label = new StyledString(proposal)
					.append(" - ", StyledString.QUALIFIER_STYLER)
					.append("instance", StyledString.DECORATIONS_STYLER);
		
		
			acceptor.accept(createCompletionProposal(proposal, label, getImage(type), context));
		}
		
		// search for sub types
		final ResourceSet rs = EcoreUtil2.getResourceSet(definition);
		for(final Resource resource : rs.getResources()) {
			if(!(resource.getContents().get(0) instanceof DefinitionModel)) {
				continue;
			}
			
			final DefinitionModel model = (DefinitionModel)resource.getContents().get(0);
			model.getCategories()
				.stream()
				.filter(cd -> Category.EVOLUTIONARY_ALGORITHM.equals(cd.getCategory()))
				.flatMap(cd -> cd.getTypes().stream())
				.filter(d -> Objects.nonNull(d.getSuperType()))
				.filter(d -> d.getSuperType().equals(definition))
				.forEach(sub -> addInstanceDefinition(sub, name, type, context, acceptor));
		}
	}

	@Override
	public void completeAttributeRule_Value(final EObject model, final Assignment assignment, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
		if(model instanceof Attribute) {
			final Attribute attr = (Attribute)model;
			if(attr.getName() instanceof Name) {
				final Name name = (Name)attr.getName();
				final Type type = name.getName().getType();
				
				if(type instanceof InstanceType) {
					final InstanceType instance = (InstanceType)type;
					
					for(final TypeDefinition id : instance.getDefinitions()) {
						addInstanceDefinition(id, name, type, context, acceptor);
					}
					return;
				}
			}
		}

		super.completeAttributeRule_Value(model, assignment, context, acceptor);
	}
	
	@Override
	public void complete_ValueRule(EObject model, RuleCall ruleCall, ContentAssistContext context,
			ICompletionProposalAcceptor acceptor) {
		System.err.println("complete_ValueRule(" + model+ ")");

		// TODO Auto-generated method stub
		//super.complete_ValueRule(model, ruleCall, context, acceptor);
	}

	private String toString(final Type type) {
		if(type instanceof ArrayType) {
			return "[" + toString(((ArrayType)type).getElements().get(0)) + "]";
		} else if(type instanceof BooleanType) {
			return "boolean";
		} else if(type instanceof FloatType) {
			return "float";
		} else if(type instanceof InstanceType) {
			return "instance ...";
		} else if(type instanceof IntType) {
			return "int";
		} else if(type instanceof StringType) {
			return "string";
		}

		return "unknown";
	}	
	
	@Override
	public void complete_ArrayRule(EObject model, RuleCall ruleCall, ContentAssistContext context,
			ICompletionProposalAcceptor acceptor) {
		System.err.println("complete_ArrayRule(" + model+ ")");
		super.complete_ArrayRule(model, ruleCall, context, acceptor);
	}
	
	@Override
	public void complete_AttributeRule(final EObject model, final RuleCall ruleCall, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
		if(model instanceof Instance) {
			final Instance instance = (Instance)model;
			
			final List<AttributeDefinition> defined = instance.getName().getAttributes();
			final List<Attribute> existing = instance.getAttributes();
			

			int counter = 1;
			for(final AttributeDefinition atDef : defined) {
				if(atDef instanceof NamedAttributeDefinition && contains(existing, (NamedAttributeDefinition)atDef)) {
					continue;
				}
				
				String name = "";
				StyledString label = new StyledString();

				if(atDef instanceof NamedAttributeDefinition) {
					final NamedAttributeDefinition named = (NamedAttributeDefinition)atDef;

					name = named.getName();
				} else {
					 name = "unnamed_" + counter++;
				}
				
				label = new StyledString(name)
							.append(" - ", StyledString.QUALIFIER_STYLER)
							.append(toString(atDef.getType()), StyledString.DECORATIONS_STYLER);
	
				acceptor.accept(createCompletionProposal(name + " := ", label, getImage(atDef), context));
				
			}
			
			return;
		}

		
		System.err.println("complete_AttributeRule(" + model+ ")");
		super.complete_AttributeRule(model, ruleCall, context, acceptor);
	}
	
	private boolean contains(final List<Attribute> attributes, final NamedAttributeDefinition def) {
		for(final Attribute attribute : attributes) {
			if(!(attribute.getName() instanceof Name)) {
				continue;
			}
			
			final Name attributeName = (Name)attribute.getName();
			
			if(attributeName.getName().equals(def)) {
				return true;
			}
		}
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void complete_BooleanLiteralRule(final EObject model, final RuleCall ruleCall, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
		System.err.println("complete_BooleanLiteralRule(" + model+ ")");
		
		super.complete_BooleanLiteralRule(model, ruleCall, context, acceptor);
	}
	
	
	private static class OnlyFirstFilter implements Predicate<IEObjectDescription> {
		boolean isFirst = true;
		
		@Override
		public boolean apply(final IEObjectDescription argument) {
			System.err.println(" --> " + argument.getName());
			if(isFirst) {
				isFirst = false;
				return true;
			}
			
			return false;
		}		
	}

	private static class OnlyCompatibleInstancesFilter implements Predicate<IEObjectDescription> {		
		private final Attribute attribute;
		private final Predicate<IEObjectDescription> filter;

		public OnlyCompatibleInstancesFilter(final Attribute attribute) {
			this.attribute = attribute;
			
			final NameOrMisc nom = attribute.getName();
			
			if(nom instanceof Name) {
				final Name name = (Name)nom;
				
				if(name.getName().getType() instanceof InstanceType) {
					final InstanceType it = (InstanceType)name.getName().getType();

					filter = d -> {
						if(!d.getEClass().equals(DlPackage.Literals.TYPE_DEFINITION)) {
							return false;
						}
						
						return it.getDefinitions()
                                 .stream()
                                 .anyMatch(id -> id.getName().equals(d.getQualifiedName().toString()));
					};
					
				} else {
					filter = d -> false;
				}
			} else {
				// TODO
				filter = d -> true;
			}
		}

		@Override
		public boolean apply(final IEObjectDescription argument) {
			return filter.apply(argument);
		}		
	}

	@Override
	public void completeInstanceRule_Name(final EObject model, final Assignment assignment, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
		System.err.println("completeInstanceRule_Name(" + model + ", " + assignment + ")");
		System.err.println("  -> terminal: " + assignment.getTerminal() + " -- " + assignment.getFeature() + " -- " + assignment.getOperator());

		
		if(model instanceof EAModel) {
			lookupCrossReference(((CrossReference)assignment.getTerminal()), context, acceptor, new OnlyFirstFilter());
		} else if(model instanceof Attribute) {
			lookupCrossReference(((CrossReference)assignment.getTerminal()), context, acceptor, new OnlyCompatibleInstancesFilter((Attribute)model));
		} else {
			lookupCrossReference(((CrossReference)assignment.getTerminal()), context, acceptor);
		}
	}
	*/
}
